From 57c166d775a4171c4e86b8394197048ccf2b7a9a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 15 2020 07:40:43 +0000
Subject: [PATCH 1393/2232] Improve error message spanning for fallible fn ptr


---

diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 500ea0b..0d6c066 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -5,7 +5,7 @@ use crate::syntax::{
 };
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{quote_spanned, ToTokens};
-use syn::Token;
+use syn::{token, Token};
 
 impl ToTokens for Type {
     fn to_tokens(&self, tokens: &mut TokenStream) {
@@ -145,6 +145,12 @@ impl ToTokens for Signature {
             } else {
                 ret.to_tokens(tokens);
             }
+        } else if let Some((result, langle, rangle)) = self.throws_tokens {
+            Token![->](self.paren_token.span).to_tokens(tokens);
+            result.to_tokens(tokens);
+            langle.to_tokens(tokens);
+            token::Paren(langle.span).surround(tokens, |_| ());
+            rangle.to_tokens(tokens);
         }
     }
 }
diff --git a/tests/ui/fallible_fnptr.stderr b/tests/ui/fallible_fnptr.stderr
index cf56c16..1d3fbe4 100644
--- a/tests/ui/fallible_fnptr.stderr
+++ b/tests/ui/fallible_fnptr.stderr
@@ -2,4 +2,4 @@ error: function pointer returning Result is not supported yet
  --> $DIR/fallible_fnptr.rs:4:24
   |
 4 |         fn f(callback: fn() -> Result<()>);
-  |                        ^^^^
+  |                        ^^^^^^^^^^^^^^^^^^

